module Rooster

    class EggTimer

        ONE_MINUTE = 60

        # Start your egg timer
        #
        # Example:
        #   >> rooster 10, "remind me to make coffee in ten minutes"
        #
        # Arguments:
        #   minutes: (Integer)
        #   text: (String)
        def initialize minutes, text
            @text = text
            @minutes = minutes.to_i

            run
        end

        private

        def run
            while @minutes > 0
                puts "=> #{@minutes} minute remaining until \"#{@text}\"."
                sleep ONE_MINUTE
                @minutes -= 1
            end
            alarm
        end

        def alarm
            beep_it
            say_it
            notification_center_it
            display_it
        end

        def beep_it
            `which tput`
            `tput bel` if $?.success?
        end

        def say_it
            `which say`
            `say #{@text}` if $?.success?
        end

        def notification_center_it
            begin
                TerminalNotifier.notify @text, :title => 'Egg Timer'
            rescue Exception => e
                # TerminalNotifier::UnsupportedPlatformError
            end
        end

        def display_it
            puts "\nTime's up.".green
            puts "\"#{@text}\"".green
        end

    end

end
